--
-- © Copyright Peregrine I.T. Pty Ltd 2004-2018 except where explicitly stated otherwise.
-- Fantasy Grounds is Copyright © 2004-2018 SmiteWorks USA LLC.
-- Copyright to other material within this file may be held by other Individuals and/or Entities.
-- Nothing in or from this LUA file in printed, electronic and/or any other form may be used, copied,
--	transmitted or otherwise manipulated in ANY way without the explicit written consent of
--	Peregrine I.T. Pty Ltd or, where applicable, any and all other Copyright holders.
-- Please see the accompanying License for full details.
-- All rights reserved.
--
-- Called By: wcManifestREMList in xREMUTemplates.xml

local sType;

function onInit()
	sType = string.sub(window.parentcontrol.getName(),3);
	for kKey1,vValue1 in pairs(GlobalRegistry.MJB_REMU["a" .. sType]) do
		local bFound = false;
		for kKey2,vValue2 in pairs(getWindows()) do
			if vValue2.name.getValue() == kKey1 then
				bFound = true;
				break;
			end
		end
		if not bFound then
			fpCreateEntry(kKey1,vValue1);
		end
	end
	applySort();
end

function fpCreateEntry(sName,aValues)
	local oWindow = createWindow();
	if oWindow then
		oWindow.name.setValue(sName);
		oWindow.sManifest.setValue(aValues["sManifestName"]);
		oWindow.sURL.setValue(aValues["sURL"]);
		oWindow.sProtocol.setValue(aValues["sProtocol"]);
		oWindow.nMajorVer.setValue(aValues["nVersionMajor"]);
		oWindow.nMinorVer.setValue(aValues["nVersionMinor"]);
		oWindow.nPatch.setValue(aValues["nVersionPatch"]);
	end
	applyFilter();
end

function fpUpdate()
	local bEdit = (window.wlListIconEdit.getValue() == 1);
	for kKey,vValue in pairs(getWindows()) do
		vValue.btIconDelete.setVisibility(bEdit);
	end
	return;
end

function fpAddEntry()
	local sManifestName = window.parentcontrol.window.parentcontrol.window.sManifestFileName.getValue();
	if window.parentcontrol.window.parentcontrol.window.nNew.getValue() == 1 then
		sManifestName = window.parentcontrol.window.parentcontrol.window.sNewManifestFileName.getValue();
	end
	local oWindow = createWindow();
	if oWindow then
		oWindow.name.setValue("New");
		oWindow.sManifest.setValue(sManifestName);
		oWindow.sURL.setValue(window.parentcontrol.window.parentcontrol.window.sURL.getValue());
		oWindow.nMajorVer.setValue(1);
		oWindow.btIconDelete.setVisibility(true);
	end
	applyFilter();
	return;
end

function onFilter(oWindow)
	local sManifestName = window.parentcontrol.window.parentcontrol.window.sManifestFileName.getValue();
	if window.parentcontrol.window.parentcontrol.window.nNew.getValue() == 1 then
		sManifestName = window.parentcontrol.window.parentcontrol.window.sNewManifestFileName.getValue();
	end
	if oWindow.sManifest.getValue() == sManifestName then
		return true;
	end
	return false;
end