--
-- © Copyright Peregrine I.T. Pty Ltd 2004-2018 except where explicitly stated otherwise.
-- Fantasy Grounds is Copyright © 2004-2018 SmiteWorks USA LLC.
-- Copyright to other material within this file may be held by other Individuals and/or Entities.
-- Nothing in or from this LUA file in printed, electronic and/or any other form may be used, copied,
--	transmitted or otherwise manipulated in ANY way without the explicit written consent of
--	Peregrine I.T. Pty Ltd or, where applicable, any and all other Copyright holders.
-- Please see the accompanying License for full details.
-- All rights reserved.
--
-- Called By: tWindowlistREM in xREMUTemplates.xml

function onInit()
	fpCheckREMEntryExists(string.sub(window.parentcontrol.getName(),3));
end

function onFilter(oWindow)
	local bResult = true;
	local oParentWindow = oWindow.windowlist.window.parentcontrol.window.parentcontrol.window;
	if oParentWindow.nHideIgnored.getValue() == 1 then
		if oParentWindow.nHideNonUpdate.getValue() == 1 then
			if oWindow.nIgnore.getValue() == 1 or
					oWindow.nUpdateable.getValue() == 0 then
				bResult = false;
			end
		elseif oWindow.nIgnore.getValue() == 1 then
			bResult = false;
		end
	elseif oParentWindow.nHideNonUpdate.getValue() == 1 then
		if oWindow.nUpdateable.getValue() == 0 then
			bResult = false;
		end
	end
	REMUManager.fpSetMenubarButton();
	return bResult;
end

function fpCreateEntry(sName,aValues,sType)
	local oWindow = createWindow();
	if oWindow then
		oWindow.name.setValue(sName);
		oWindow.nUpdateable.setValue(aValues["nUpdateable"]);
		oWindow.sType.setValue(sType);
		oWindow.sInstalledVer.setValue("" .. aValues["nVersionMajor"] .. "." .. aValues["nVersionMinor"] .. "." .. aValues["nVersionPatch"]);
		oWindow.sCurrVer.setValue("" .. aValues["nVersionMajorNew"] .. "." .. aValues["nVersionMinorNew"] .. "." .. aValues["nVersionPatchNew"]);
		oWindow.nIgnore.setValue(aValues["nIgnore"]);
	end
	applyFilter();
end

function fpCheckREMEntryExists(sType)
	for kKey1,vValue1 in pairs(GlobalRegistry.MJB_REMU["a" .. sType]) do
		local bFound = false;
		for kKey2,vValue2 in pairs(getWindows()) do
			if vValue2.name.getValue() == kKey1 then
				bFound = true;
				break;
			end
		end
		if not bFound then
			fpCreateEntry(kKey1,vValue1,sType);
		end
	end
	applySort();
	return;
end

function fpUpdate(sType)
	for kKey1,vValue1 in pairs(GlobalRegistry.MJB_REMU["a" .. sType]) do
		for kKey2,vValue2 in pairs(getWindows()) do
			if vValue2.name.getValue() == kKey1 then
				vValue2.sInstalledVer.setValue(vValue2.sCurrVer.getValue());
				vValue2.nUpdateable.setValue(0);
				break;
			end
		end
	end
	applySort();
	return;
end
