--
-- © Copyright Peregrine I.T. Pty Ltd 2004-2018 except where explicitly stated otherwise.
-- Fantasy Grounds is Copyright © 2004-2018 SmiteWorks USA LLC.
-- Copyright to other material within this file may be held by other Individuals and/or Entities.
-- Nothing in or from this LUA file in printed, electronic and/or any other form may be used, copied,
--	transmitted or otherwise manipulated in ANY way without the explicit written consent of
--	Peregrine I.T. Pty Ltd or, where applicable, any and all other Copyright holders.
-- Please see the accompanying License for full details.
-- All rights reserved.
--
-- Called By: wcREMUWindow in xREMUWindowClasses.xml
--

function onInit()
	self.onSizeChanged = fpHandleSizeChanged;
	fpUpdate();
end

function fpHandleSizeChanged()
	local nWidth,nHeight = getSize();
	local bRuleset = false;
	local bExtension = false;
	local bModule = false;
	if swRulesets.subwindow then
		bRuleset = (swRulesets.subwindow.wlList.getWindowCount(true) ~= 0);
	end
	if swExtensions.subwindow then
		bExtension = (swExtensions.subwindow.wlList.getWindowCount(true) ~= 0);
	end
	if swModules.subwindow then
		bModule = (swModules.subwindow.wlList.getWindowCount(true) ~= 0);
	end
	local nLists = 0;
	if bRuleset then
		nLists = nLists+1;
	end
	if bExtension then
		nLists = nLists+1;
	end
	if bModule then
		nLists = nLists+1;
	end
	if nLists == 0 then
		nLists = 1;
	end
	nHeight = math.floor((nHeight+3)/nLists)-9;
	swRulesets.setAnchoredHeight(nHeight);
	swExtensions.setAnchoredHeight(nHeight);
	swModules.setAnchoredHeight(nHeight);
end

function fpUpdate()
	local bRuleset = false;
	local bExtension = false;
	local bModule = false;
	if swRulesets and
			swRulesets.subwindow then
		bRuleset = (swRulesets.subwindow.wlList.getWindowCount(true) ~= 0);
	end
	if swExtensions and
			swExtensions.subwindow then
		bExtension = (swExtensions.subwindow.wlList.getWindowCount(true) ~= 0);
	end
	if swModules and
			swModules.subwindow then
		bModule = (swModules.subwindow.wlList.getWindowCount(true) ~= 0);
	end
	if not (bRuleset or bExtension or bModule) then
		bRuleset = true;
	end
	swRulesets.setVisible(bRuleset);
	swExtensions.setVisible(bExtension);
	swModules.setVisible(bModule);
	Line1.setVisible(bRuleset and (bExtension or bModule));
	Line2.setVisible(bExtension and bModule);
	fpHandleSizeChanged();
end
